#pragma once

#include <netinet/in.h>

namespace ts {
    namespace connection {
        class FilteredUdpSocket {
            public:
                FilteredUdpSocket();
                ~FilteredUdpSocket();

                bool setup(sockaddr_in*);
                void close();

                ssize_t read(char* buffer, size_t size);
                ssize_t write(const char* buffer, size_t size);

                int getSocketDescriptor(){ return socketDescriptor; }
            private:
                int socketDescriptor;
                sockaddr_in* remoteAdress = nullptr;
                sockaddr_in* localAdress = nullptr;
        };

        typedef FilteredUdpSocket UdpSocket;
    }
}