#!/usr/bin/env bash

BUILD_INFO=($(cat build_version.txt))
BUILD_FULL_NAME=${BUILD_INFO[0]}
BUILD_NAME=${BUILD_INFO[1]}
BUILD_VERSION=${BUILD_INFO[2]}
BUILD_FILENAME=${BUILD_INFO[3]}

echo "Creating TeaSpeak ${BUILD_NAME} Build index ${BUILD_VERSION}"

cp -r env finalenv
cd finalenv
echo -e "# Version: ${BUILD_FULL_NAME}
# TeaSpeak version: ${BUILD_NAME}
# Build version: ${BUILD_VERSION}

{build_name: \"${BUILD_FULL_NAME}\", build_version: \"${BUILD_NAME}\", build_index: ${BUILD_VERSION}}" > buildVersion.txt

#Create a copy and save unstripped
cp TeaSpeakServer TeaSpeakServerTmp
rm TeaSpeakServer
mv TeaSpeakServerTmp TeaSpeakServer

strip -s -p -v TeaSpeakServer
tar --dereference -czvf "../${BUILD_FILENAME}" *
cd ..
rm -r finalenv
./make_symbol.sh

echo "Package created (${BUILD_FILENAME})"
