#pragma once

#include <sql/SqlQuery.h>

namespace ts {
	namespace server {
		class SqlDataManager {
			public:
				SqlDataManager();
				virtual ~SqlDataManager();

				int getVersion() { return this->version; }
				bool initialize(std::string&);
				void finalize();

				sql::SqlManager* sql() { return this->manager; }
			private:
				sql::SqlManager* manager = nullptr;
				int version = -1;
				bool version_present = false;

				void detectVersion();
				void changeVersion(int);
		};
	}
}