#pragma once

#include <vector>
#include <sched.h>
#include <string>

namespace interaction {
    struct InstanceInfo {
        pid_t pid = 0;

        size_t virtualServers = 0;
        size_t usedSlots = 0;
    } __attribute__((packed));

    template <size_t N>
    struct MemoryInfo {
        pthread_mutex_t memoryLock = PTHREAD_MUTEX_INITIALIZER;

        size_t instanceCount = 0;
        size_t maxInstances = N;
        bool infoUsed[N];
        InstanceInfo info[N];
    } __attribute__((packed));

    typedef MemoryInfo<15> DefaultMemoryInfo;


    struct RunningInstanceInfo {
        std::string name;
        pid_t pid;

        int usedSlots;
    };

    std::vector<RunningInstanceInfo> listInstances();

    bool waitForAttach(std::string& error);

    void removeMemoryHook();

    DefaultMemoryInfo* memoryInfo();
    InstanceInfo* ownInfo();
}